<template>
  <SinglePane capt="Ресурсы">
    <div class="resources-page">
      <div class="tabs-container">
        <ObTabs
          ref="resources-tabs"
          :items="modifiedTabs"
          @on-change-tab="onChangeTab"
        />
      </div>

      <ObTable
        ref="resources-table"
        :remote-opt="{
          method: getResourcesList,
          arguments: {
            carrier_uuid,
            filter: filterValue
          }
        }"
        :columns="finalColumns"
        :selected="{}"
        :functional-panel="true"
        :show-add-button="true"
        :is-functional-group="false"
        :is-functional-sort="false"
        :table-layout-fixed="true"
        @add="onAdd"
        @select="onSelect"
      >
        <template slot="extraFuncButtons">
          <ObSwitcher
            label-right="Только в статусе “Активно”"
            v-model="hideInactive"
            @on-change="loadData('resources-table')"
          />
        </template>
        <template slot="risks" slot-scope="{ data }">
          <div
            v-if="data.item.riskGroupColor"
            class="risk-group"
          >
            <span v-html="getRiskIcon(data.item.riskGroupColor)"></span>
            <ObTooltip
              v-if="data.item.isTemporaryRisk"
              :content="`Проверка участника ещё не завершена. Временно присвоена группа риска ${getNumberRisk(data.item.riskGroupColor)}`"
            >
              <span class="pending-risk">Временная оценка</span>
            </ObTooltip>
          </div>
          <ObTooltip v-else content="Оценка не проведена">
            <i class="icon clock resources-icon-clock -gray-window" />
          </ObTooltip>
        </template>
      </ObTable>

      <ObModal
        ref="ob-modal-resource-add"
        size="medium"
        title-second="Добавление"
        :title="addModalTitle"
      >
        <!-- Используется :key для того, чтобы менялся компонент trailer.vue,
        который отвечается одновременно и за прицепы и за полуприцепы -->
        <component
          :is="`add-${selectedTab.name}`"
          :key="selectedTab.name"
          :resource-title="addModalTitle"
          @success-submit="onSubmit"
        />
      </ObModal>
    </div>
  </SinglePane>
</template>

<script>
import { uuid } from "vue-uuid";
import api from "@/api";
import { columns } from "./mock.js";
import riskIconMixin from "@/mixins/risk-icon";
import { mapGetters } from "vuex";

import SinglePane from "common-components/src/obComponents/obSinglePanels";
import ObTable from "common-components/src/obComponents/obTable";
import ObTabs from "common-components/src/obComponents/obTabs/index";
import ObModal from "common-components/src/obComponents/obModal";
import ObSwitcher from "common-components/src/obComponents/obSwitcher";
import ObTooltip from "common-components/src/obComponents/obTooltip";

import AddTractor from "./modal/add/tractor";
import AddTrailer from "./modal/add/trailer";
import AddSemitrailer from "./modal/add/trailer";
import AddDriver from "./modal/add/driver";
import AddWagon from "./modal/add/wagon";
import AddContainertruck from "./modal/add/containertruck";
import AddTral from "./modal/add/trailer";
import AddJumbo from "./modal/add/trailer";
import AddLst from "./modal/add/trailer";

export default {
  name: "provider-index",
  components: {
    SinglePane,
    ObTable,
    ObTabs,
    ObModal,
    ObTooltip,
    ObSwitcher,
    AddTractor,
    AddTrailer,
    AddSemitrailer,
    AddDriver,
    AddWagon,
    AddContainertruck,
    AddTral,
    AddJumbo,
    AddLst
  },
  mixins: [
    riskIconMixin
  ],
  computed: {
    ...mapGetters({
      participantUuid: "user/participantUuid",
      isModerator: "user/isModerator",
      isCarrier: "user/isCarrier"
    }),
    addModalTitle: ({ selectedTab }) => selectedTab.singleResourceTitle,
    selectedTab: ({ tabs, selectedTabId }) => tabs.find(tab => tab.id === selectedTabId),
    modifiedColumns: ({ selectedTab }) => columns[selectedTab.name],
    filterValue: ({ hideInactive }) => (hideInactive ? "active" : null),
    finalColumns: ({ modifiedColumns, isModerator }) => {
      if (isModerator) {
        return [
          {
            title: "Владелец",
            key: "carrierTitle",
            html: ({ carrierTitle, isActive }) => {
              if (carrierTitle) {
                return isActive
                  ? carrierTitle
                  : `<span class="text-disabled text-crossed">${carrierTitle}</span>`;
              } else {
                return null;
              }
            }
          },
          ...modifiedColumns
        ];
      } else {
        return modifiedColumns;
      }
    },
    modifiedTabs: ({ tabs, isModerator, isCarrier }) => 
      isModerator || isCarrier ? tabs.filter(tab => tab.name !== "trailer") : tabs
  },
  data() {
    return {
      tabs: [
        {
          title: "Тягачи",
          singleResourceTitle: "Тягач",
          name: "tractor",
          id: 1
        },
        {
          title: "Водители",
          singleResourceTitle: "Водитель",
          name: "driver",
          id: 2
        },
        {
          title: "Полуприцепы",
          singleResourceTitle: "Полуприцеп",
          name: "semitrailer",
          id: 3
        },
        {
          title: "Прицепы",
          singleResourceTitle: "Прицеп",
          name: "trailer",
          id: 4
        },
        {
          title: "Контейнеровозы",
          singleResourceTitle: "Контейнеровоз",
          name: "containertruck",
          id: 5
        },
        {
          title: "Фургоны",
          singleResourceTitle: "Фургон",
          name: "wagon",
          id: 6
        },
        {
          title: "Тралы",
          singleResourceTitle: "Трал",
          name: "tral",
          id: 7
        },
        {
          title: "Джамбо",
          singleResourceTitle: "Джамбо",
          name: "jumbo",
          id: 8
        },
        {
          title: "Длинномер",
          singleResourceTitle: "Длинномер",
          name: "lst",
          id: 9
        }
      ],
      hideInactive: false,
      selectedTabId: 1,
      carrier_uuid: null,
    };
  },
  created() {
    let carrier_uuid;

    if (this.isModerator) {
      carrier_uuid = this.$route.query.carrier_uuid
        ? this.$route.query.carrier_uuid
        : null;
    } else {
      carrier_uuid = this.participantUuid;
    }

    this.carrier_uuid = carrier_uuid;
  },
  methods: {
    async getResourcesList(args) {
      let response;

      switch (this.selectedTab.name) {
        case "tractor":
          response = await api.resources.getTractorsList({ ...args });
          break;
        case "wagon":
          response = await api.resources.getWagonsList({ ...args });
          break;
        case "driver":
          response = await api.resources.getDriversList({ ...args });
          break;
        case "semitrailer":
          response = await api.resources.getSemitrailersList({ ...args, semitrailer_type: "ORIGINAL" });
          break;
        case "trailer":
          response = await api.resources.getTrailersList({ ...args });
          break;
        case "containertruck":
          response = await api.resources.getContainerTrucksList({ ...args });
          break;
        case "tral":
          response = await api.resources.getSemitrailersList({ ...args, semitrailer_type: "TRALS" });
          break;
        case "jumbo":
          response = await api.resources.getSemitrailersList({ ...args, semitrailer_type: "JUMBO" });
          break;
        case "lst":
          response = await api.resources.getSemitrailersList({ ...args, semitrailer_type: "LST" });
          break;
      }

      const {
        number_of_elements,
        page,
        size,
        total_elements,
        total_pages
      } = response;

      return {
        number_of_elements,
        page,
        size,
        total_elements,
        total_pages,
        content: Object.values(response.content)[0]
      };
    },
    loadData(refName) {
      this.$nextTick(() => {
        this.$refs[refName].loadData({ init: true });
      });
    },
    // 👂 Events
    onSelect(resource) {
      this.$router.push({
        path: (this.isModerator ? '/sb_resource/' : '/resources/') + resource.uuid
      });
    },
    async onSave(payload) {
      try {
        await api.resources.addResource(uuid.v4(), payload);

        this.$refs["ob-modal-resource-add"].close();

        await this.fetch();

        this.$notification({
          type: "system_notification_success",
          message: "Сохранено"
        });
      } catch (e) {
        console.error(e);

        this.$notification({
          type: "system_notification_error",
          message: "Не сохранено"
        });
      } finally {
        this.$notification({
          event: "close",
          id: "save"
        });
      }
    },
    onAdd() {
      this.$refs["ob-modal-resource-add"].open();
    },
    onSubmit() {
      this.$refs["ob-modal-resource-add"].close();

      this.loadData("resources-table");
    },
    onChangeTab({ id }) {
      this.selectedTabId = id;
      this.loadData("resources-table");
    }
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";
@import "~common-components/src/assets/style/ob-style";

.resources-page {
  position: relative;
  height: 100%;

  &::v-deep {
    td {
      > div {
        display: flex;
        align-items: center;

        > span {
          display: flex;
          align-items: center;
        }
      }

      .text-disabled {
        color: $gray-slate;
      }

      .text-crossed {
        text-decoration: line-through;
      }

      .date {
        display: flex;
        flex-direction: column;
        line-height: 1.5;

        span {
          color: $color-grey-label;
        }
      }
    }

    .pending-risk {
      font-size: 12px;
      line-height: 12px;
      color: $saturated-yellow;
    }

    .risk-group {
      display: flex;
      align-items: center;
    }

    .field-datetime {
      @include font-mixin(14px, 20px, 400);

      .field-time {
        color: $color-grey-span;
      }
    }

    .icon {
      font-size: 24px;

      &.clock {
        font-size: 20px;

        &::before {
          color: $gray-window;
        }
      }
    }
  }

  .tabs-container {
    padding: 20px 20px 0;
  }

  .resources-icon-clock {
    cursor: help;
  }
}
</style>
